-#!/usr/pkg/bin/perl
+#!/usr/bin/perl
package IkiWiki::Plugin::cvs;
+# Copyright (c) 2009 Amitai Schlair
+# All rights reserved.
+#
+# This code is derived from software contributed to ikiwiki
+# by Amitai Schlair.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY IKIWIKI AND CONTRIBUTORS ``AS IS''
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION
+# OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
use warnings;
use strict;
use IkiWiki;
+use File::chdir;
+
sub import {
+ hook(type => "genwrapper", id => "cvs", call => \&genwrapper);
hook(type => "checkconfig", id => "cvs", call => \&checkconfig);
hook(type => "getsetup", id => "cvs", call => \&getsetup);
hook(type => "rcs", id => "rcs_update", call => \&rcs_update);
hook(type => "rcs", id => "rcs_recentchanges", call => \&rcs_recentchanges);
hook(type => "rcs", id => "rcs_diff", call => \&rcs_diff);
hook(type => "rcs", id => "rcs_getctime", call => \&rcs_getctime);
+ hook(type => "rcs", id => "rcs_getmtime", call => \&rcs_getmtime);
+}
+
+sub genwrapper () {
+ return <<EOF;
+ {
+ int j;
+ for (j = 1; j < argc; j++)
+ if (strstr(argv[j], "New directory") != NULL)
+ exit(0);
+ }
+EOF
}
sub checkconfig () {
plugin => {
safe => 0, # rcs plugin
rebuild => undef,
+ section => "rcs",
},
cvsrepo => {
type => "string",
cvs_wrapper => {
type => "string",
example => "/cvs/wikirepo/CVSROOT/post-commit",
- description => "cvs post-commit hook to generate (triggered by CVSROOT/loginfo entry",
+ description => "cvs post-commit hook to generate (triggered by CVSROOT/loginfo entry)",
safe => 0, # file
rebuild => 0,
},
my $field=shift;
my $file=shift;
- chdir $config{srcdir} || error("Cannot chdir to $config{srcdir}: $!");
+ local $CWD = $config{srcdir};
my $info=`cvs status $file`;
my ($ret)=$info=~/^\s*$field:\s*(\S+)/m;
}
sub cvs_runcvs(@) {
- my ($cmd) = @_;
- unshift @$cmd, 'cvs', '-Q';
-
- eval q{use IPC::Cmd};
- error($@) if $@;
-
- chdir $config{srcdir} || error("Cannot chdir to $config{srcdir}: $!");
+ my @cmd = @_;
+ unshift @cmd, 'cvs', '-Q';
- debug("runcvs: " . join(" ", @$cmd));
+ local $CWD = $config{srcdir};
- my ($success, $error_code, $full_buf, $stdout_buf, $stderr_buf) =
- IPC::Cmd::run(command => $cmd, verbose => 0);
- if (! $success) {
- warn(join(" ", @$cmd) . " exited with code $error_code\n");
- warn(join "", @$stderr_buf);
- }
- return $success;
-}
-
-sub cvs_shquote_commit ($) {
- my $message = shift;
-
- eval q{use String::ShellQuote};
- error($@) if $@;
+ open(my $savedout, ">&STDOUT");
+ open(STDOUT, ">", "/dev/null");
+ my $ret = system(@cmd);
+ open(STDOUT, ">&", $savedout);
- return shell_quote(IkiWiki::possibly_foolish_untaint($message));
+ return ($ret == 0) ? 1 : 0;
}
sub cvs_is_controlling {
sub rcs_update () {
return unless cvs_is_controlling;
- cvs_runcvs(['update', '-dP']);
+ cvs_runcvs('update', '-dP');
}
sub rcs_prepedit ($) {
if (defined $rev && defined $oldrev && $rev != $oldrev) {
# Merge their changes into the file that we've
# changed.
- cvs_runcvs(['update', $file]) ||
+ cvs_runcvs('update', $file) ||
warn("cvs merge from $oldrev to $rev failed\n");
}
- if (! cvs_runcvs(['commit', '-m', cvs_shquote_commit $message])) {
+ if (! cvs_runcvs('commit', '-m',
+ IkiWiki::possibly_foolish_untaint $message)) {
my $conflict=readfile("$config{srcdir}/$file");
- cvs_runcvs(['update', '-C', $file]) ||
+ cvs_runcvs('update', '-C', $file) ||
warn("cvs revert failed\n");
return $conflict;
}
$message="web commit from $ipaddr".(length $message ? ": $message" : "");
}
- if (! cvs_runcvs(['commit', '-m', cvs_shquote_commit $message])) {
+ if (! cvs_runcvs('commit', '-m',
+ IkiWiki::possibly_foolish_untaint $message)) {
warn "cvs staged commit failed\n";
return 1; # failure
}
}
while ($file = pop @files_to_add) {
- if ((@files_to_add == 0) &&
- (File::MimeInfo::default $file ne 'text/plain')) {
- # it's a binary file, add specially
- cvs_runcvs(['add', '-kb', $file]) ||
- warn("cvs add $file failed\n");
- } else {
- # directory or regular file
- cvs_runcvs(['add', $file]) ||
+ if (@files_to_add == 0) {
+ # file
+ my $filemime = File::MimeInfo::default($file);
+ if (defined($filemime) && $filemime eq 'text/plain') {
+ cvs_runcvs('add', $file) ||
+ warn("cvs add $file failed\n");
+ }
+ else {
+ cvs_runcvs('add', '-kb', $file) ||
+ warn("cvs add binary $file failed\n");
+ }
+ }
+ else {
+ # directory
+ cvs_runcvs('add', $file) ||
warn("cvs add $file failed\n");
}
}
return unless cvs_is_controlling;
- cvs_runcvs(['rm', '-f', $file]) ||
+ cvs_runcvs('rm', '-f', $file) ||
warn("cvs rm $file failed\n");
}
return unless cvs_is_controlling;
- chdir $config{srcdir} || error("Cannot chdir to $config{srcdir}: $!");
+ local $CWD = $config{srcdir};
if (system("mv", "$src", "$dest") != 0) {
warn("filesystem rename failed\n");
eval q{use Date::Parse};
error($@) if $@;
- chdir $config{srcdir} || error("Cannot chdir to $config{srcdir}: $!");
+ local $CWD = $config{srcdir};
+
+ # There's no cvsps option to get the last N changesets.
+ # Write full output to a temp file and read backwards.
+
+ eval q{use File::Temp qw/tempfile/};
+ error($@) if $@;
+ eval q{use File::ReadBackwards};
+ error($@) if $@;
+
+ my ($tmphandle, $tmpfile) = tempfile();
+ system("env TZ=UTC cvsps -q --cvs-direct -z 30 -x >$tmpfile");
+ if ($? == -1) {
+ error "couldn't run cvsps: $!\n";
+ }
+ elsif (($? >> 8) != 0) {
+ error "cvsps exited " . ($? >> 8) . ": $!\n";
+ }
- # there's no option to get the last N changesets, so read backwards
- open CVSPS, "env TZ=UTC cvsps -q --cvs-direct -z 30 -x |" || error "couldn't get cvsps output: $!\n";
- my @spsvc = reverse <CVSPS>; # is this great? no it is not
- close CVSPS || error "couldn't close cvsps output: $!\n";
+ tie(*SPSVC, 'File::ReadBackwards', $tmpfile)
+ || error "couldn't open $tmpfile for read: $!\n";
- while (my $line = shift @spsvc) {
+ while (my $line = <SPSVC>) {
$line =~ /^$/ || error "expected blank line, got $line";
my ($rev, $user, $committype, $when);
# @pages (and revisions)
#
- while ($line = shift @spsvc) {
+ while ($line = <SPSVC>) {
last if ($line =~ /^Members:/);
for ($line) {
s/^\s+//;
} if length $page;
}
- while ($line = shift @spsvc) {
+ while ($line = <SPSVC>) {
last if ($line =~ /^Log:$/);
chomp $line;
unshift @message, { line => $line };
$message[0]->{line}=~/$config{web_commit_regexp}/) {
$user=defined $2 ? "$2" : "$3";
$message[0]->{line}=$4;
- } else {
+ }
+ else {
$committype="cvs";
}
- $line = shift @spsvc; # Tag
- $line = shift @spsvc; # Branch
+ $line = <SPSVC>; # Tag
+ $line = <SPSVC>; # Branch
- $line = shift @spsvc;
+ $line = <SPSVC>;
if ($line =~ /^Author: (.*)$/) {
$user = $1 unless defined $user && length $user;
- } else {
+ }
+ else {
error "expected Author, got $line";
}
- $line = shift @spsvc;
+ $line = <SPSVC>;
if ($line =~ /^Date: (.*)$/) {
$when = str2time($1, 'UTC');
- } else {
+ }
+ else {
error "expected Date, got $line";
}
- $line = shift @spsvc;
+ $line = <SPSVC>;
if ($line =~ /^PatchSet (.*)$/) {
$rev = $1;
- } else {
+ }
+ else {
error "expected PatchSet, got $line";
}
- $line = shift @spsvc; # ---------------------
+ $line = <SPSVC>; # ---------------------
push @ret, {
rev => $rev,
message => [@message],
pages => [@pages],
} if @pages;
- return @ret if @ret >= $num;
+ last if @ret >= $num;
}
+ unlink($tmpfile) || error "couldn't unlink $tmpfile: $!\n";
+
return @ret;
}
sub rcs_diff ($) {
my $rev=IkiWiki::possibly_foolish_untaint(int(shift));
- chdir $config{srcdir} || error("Cannot chdir to $config{srcdir}: $!");
+ local $CWD = $config{srcdir};
# diff output is unavoidably preceded by the cvsps PatchSet entry
my @cvsps = `env TZ=UTC cvsps -q --cvs-direct -z 30 -g -s $rev`;
if (wantarray) {
return @cvsps;
- } else {
+ }
+ else {
return join("", @cvsps);
}
}
return $date;
}
+sub rcs_getmtime ($) {
+ error "rcs_getmtime is not implemented for cvs\n"; # TODO
+}
+
1